//<File !Start!>
// FILE: [HJNlpu_GSLC.h]
// Created by GUIslice Builder version: [0.17.b24]
//
// GUIslice Builder Generated GUI Framework File
//
// For the latest guides, updates and support view:
// https://github.com/ImpulseAdventure/GUIslice
//
//<File !End!>

#ifndef _GUISLICE_GEN_H
#define _GUISLICE_GEN_H

// ------------------------------------------------
// Headers to include
// ------------------------------------------------
#include "GUIslice.h"
#include "GUIslice_drv.h"

// Include any extended elements
//<Includes !Start!>
// Include extended elements
#include "elem/XGraph.h"
//<Includes !End!>

// ------------------------------------------------
// Headers and Defines for fonts
// Note that font files are located within the Adafruit-GFX library folder:
// ------------------------------------------------
//<Fonts !Start!>
#if defined(DRV_DISP_TFT_ESPI)
  #error E_PROJECT_OPTIONS tab->Graphics Library should be TFT_eSPI
#endif
#include <Adafruit_GFX.h>
//<Fonts !End!>

// ------------------------------------------------
// Defines for resources
// ------------------------------------------------
//<Resources !Start!>
//<Resources !End!>

// ------------------------------------------------
// Enumerations for pages, elements, fonts, images
// ------------------------------------------------
//<Enum !Start!>
enum {E_PG_MAIN};
enum {AmpsMax,AmpsMin,Current,CurrentGraph,CurrentMeas,SecDiv,VoltMeas
      ,Voltage,VoltageGraph,VoltsMax,VoltsMin};
// Must use separate enum for fonts with MAX_FONT at end to use gslc_FontSet.
enum {E_BUILTIN5X8,MAX_FONT};
//<Enum !End!>

// ------------------------------------------------
// Instantiate the GUI
// ------------------------------------------------

// ------------------------------------------------
// Define the maximum number of elements and pages
// ------------------------------------------------
//<ElementDefines !Start!>
#define MAX_PAGE                1

#define MAX_ELEM_PG_MAIN 11 // # Elems total on page
#define MAX_ELEM_PG_MAIN_RAM MAX_ELEM_PG_MAIN // # Elems in RAM
//<ElementDefines !End!>

// ------------------------------------------------
// Create element storage
// ------------------------------------------------
gslc_tsGui                      m_gui;
gslc_tsDriver                   m_drv;
gslc_tsFont                     m_asFont[MAX_FONT];
gslc_tsPage                     m_asPage[MAX_PAGE];

//<GUI_Extra_Elements !Start!>
gslc_tsElem                     m_asPage1Elem[MAX_ELEM_PG_MAIN_RAM];
gslc_tsElemRef                  m_asPage1ElemRef[MAX_ELEM_PG_MAIN];
gslc_tsXGraph                   m_sGraph1;
int16_t                         m_anGraphBuf1[256]; // NRows=256
gslc_tsXGraph                   m_sGraph3;
int16_t                         m_anGraphBuf3[256]; // NRows=256

#define MAX_STR                 100

//<GUI_Extra_Elements !End!>

// ------------------------------------------------
// Program Globals
// ------------------------------------------------

// Element References for direct access
//<Extern_References !Start!>
extern gslc_tsElemRef* cGraph;
extern gslc_tsElemRef* cMax;
extern gslc_tsElemRef* cMeas;
extern gslc_tsElemRef* secDiv;
extern gslc_tsElemRef* vGraph;
extern gslc_tsElemRef* vMax;
extern gslc_tsElemRef* vMeas;
//<Extern_References !End!>

// Define debug message function
static int16_t DebugOut(char ch);

// ------------------------------------------------
// Callback Methods
// ------------------------------------------------
bool CbBtnCommon(void* pvGui,void *pvElemRef,gslc_teTouch eTouch,int16_t nX,int16_t nY);
bool CbCheckbox(void* pvGui, void* pvElemRef, int16_t nSelId, bool bState);
bool CbDrawScanner(void* pvGui,void* pvElemRef,gslc_teRedrawType eRedraw);
bool CbKeypad(void* pvGui, void *pvElemRef, int16_t nState, void* pvData);
bool CbListbox(void* pvGui, void* pvElemRef, int16_t nSelId);
bool CbSlidePos(void* pvGui,void* pvElemRef,int16_t nPos);
bool CbSpinner(void* pvGui, void *pvElemRef, int16_t nState, void* pvData);
bool CbTickScanner(void* pvGui,void* pvScope);

// ------------------------------------------------
// Create page elements
// ------------------------------------------------
void InitGUIslice_gen()
{
  gslc_tsElemRef* pElemRef = NULL;

  if (!gslc_Init(&m_gui,&m_drv,m_asPage,MAX_PAGE,m_asFont,MAX_FONT)) { return; }

  // ------------------------------------------------
  // Load Fonts
  // ------------------------------------------------
//<Load_Fonts !Start!>
    if (!gslc_FontSet(&m_gui,E_BUILTIN5X8,GSLC_FONTREF_PTR,NULL,1)) { return; }
//<Load_Fonts !End!>

//<InitGUI !Start!>
  gslc_PageAdd(&m_gui,E_PG_MAIN,m_asPage1Elem,MAX_ELEM_PG_MAIN_RAM,m_asPage1ElemRef,MAX_ELEM_PG_MAIN);

  // NOTE: The current page defaults to the first page added. Here we explicitly
  //       ensure that the main page is the correct page no matter the add order.
  gslc_SetPageCur(&m_gui,E_PG_MAIN);
  
  // Set Background to a flat color
  gslc_SetBkgndColor(&m_gui,GSLC_COL_BLACK);

  // -----------------------------------
  // PAGE: E_PG_MAIN
  

  // Create graph CurrentGraph
  pElemRef = gslc_ElemXGraphCreate(&m_gui,CurrentGraph,E_PG_MAIN,
    &m_sGraph1,(gslc_tsRect){9,71,100,50},E_BUILTIN5X8,(int16_t*)&m_anGraphBuf1,
        256,GSLC_COL_RED);
  gslc_ElemXGraphSetStyle(&m_gui,pElemRef, GSLCX_GRAPH_STYLE_FILL, 5);
  gslc_ElemSetCol(&m_gui,pElemRef,GSLC_COL_GRAY_DK2,GSLC_COL_BLACK,GSLC_COL_BLACK);
  cGraph = pElemRef;

  // Create graph VoltageGraph
  pElemRef = gslc_ElemXGraphCreate(&m_gui,VoltageGraph,E_PG_MAIN,
    &m_sGraph3,(gslc_tsRect){10,10,100,50},E_BUILTIN5X8,(int16_t*)&m_anGraphBuf3,
        256,GSLC_COL_BLUE_LT4);
  gslc_ElemXGraphSetStyle(&m_gui,pElemRef, GSLCX_GRAPH_STYLE_FILL, 5);
  gslc_ElemSetCol(&m_gui,pElemRef,GSLC_COL_GRAY_DK2,GSLC_COL_BLACK,GSLC_COL_BLACK);
  vGraph = pElemRef;
  
  // Create Voltage text label
  pElemRef = gslc_ElemCreateTxt(&m_gui,Voltage,E_PG_MAIN,(gslc_tsRect){10,0,42,8},
    (char*)"Voltage",0,E_BUILTIN5X8);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  
  // Create Current text label
  pElemRef = gslc_ElemCreateTxt(&m_gui,Current,E_PG_MAIN,(gslc_tsRect){9,62,42,8},
    (char*)"Current",0,E_BUILTIN5X8);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  
  // Create SecDiv runtime modifiable text
  static char m_sDisplayText3[17] = "Sec/div  1.00";
  pElemRef = gslc_ElemCreateTxt(&m_gui,SecDiv,E_PG_MAIN,(gslc_tsRect){9,123,96,8},
    (char*)m_sDisplayText3,17,E_BUILTIN5X8);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  secDiv = pElemRef;
  
  // Create VoltsMin text label
  pElemRef = gslc_ElemCreateTxt(&m_gui,VoltsMin,E_PG_MAIN,(gslc_tsRect){111,51,12,8},
    (char*)"0v",0,E_BUILTIN5X8);
  gslc_ElemSetTxtAlign(&m_gui,pElemRef,GSLC_ALIGN_BOT_LEFT);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  
  // Create VoltsMax runtime modifiable text
  static char m_sDisplayText5[6] = "32v";
  pElemRef = gslc_ElemCreateTxt(&m_gui,VoltsMax,E_PG_MAIN,(gslc_tsRect){111,10,18,8},
    (char*)m_sDisplayText5,6,E_BUILTIN5X8);
  gslc_ElemSetTxtAlign(&m_gui,pElemRef,GSLC_ALIGN_MID_RIGHT);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  vMax = pElemRef;
  
  // Create AmpsMin text label
  pElemRef = gslc_ElemCreateTxt(&m_gui,AmpsMin,E_PG_MAIN,(gslc_tsRect){111,112,12,10},
    (char*)"0A",0,E_BUILTIN5X8);
  gslc_ElemSetTxtAlign(&m_gui,pElemRef,GSLC_ALIGN_BOT_LEFT);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  
  // Create AmpsMax runtime modifiable text
  static char m_sDisplayText7[6] = "10A";
  pElemRef = gslc_ElemCreateTxt(&m_gui,AmpsMax,E_PG_MAIN,(gslc_tsRect){109,71,18,8},
    (char*)m_sDisplayText7,6,E_BUILTIN5X8);
  gslc_ElemSetTxtAlign(&m_gui,pElemRef,GSLC_ALIGN_MID_RIGHT);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  cMax = pElemRef;
  
  // Create CurrentMeas runtime modifiable text
  static char m_sDisplayText8[13] = "0.00A";
  pElemRef = gslc_ElemCreateTxt(&m_gui,CurrentMeas,E_PG_MAIN,(gslc_tsRect){60,62,72,8},
    (char*)m_sDisplayText8,13,E_BUILTIN5X8);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  cMeas = pElemRef;
  
  // Create VoltMeas runtime modifiable text
  static char m_sDisplayText9[13] = "0.00 V";
  pElemRef = gslc_ElemCreateTxt(&m_gui,VoltMeas,E_PG_MAIN,(gslc_tsRect){60,1,72,8},
    (char*)m_sDisplayText9,13,E_BUILTIN5X8);
  gslc_ElemSetFillEn(&m_gui,pElemRef,false);
  vMeas = pElemRef;
//<InitGUI !End!>

//<Startup !Start!>
//<Startup !End!>

}

#endif // end _GUISLICE_GEN_H
